package com.yizhi.assignment.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.assignment.application.vo.entity.AssignmentAnswerTipoff;
import com.yizhi.assignment.application.vo.AssignmentStudentExerciseBookListVO;
import com.yizhi.assignment.application.vo.apivo.ApiAssignmentCommentVO;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

/**
 * @ClassName ApiAssignmentExerciseBookClient
 * @Description TODO
 * @Author shengchenglong
 * @DATE 2019-10-22 11:15
 * @Version 1.0
 */
@FeignClient(name = "assignment", contextId = "ApiAssignmentExerciseBookClient")
public interface ApiAssignmentExerciseBookClient {

    @GetMapping("/remote/api/assignment/exerciseBook/page")
    Page<AssignmentStudentExerciseBookListVO> list(
            @ApiParam("作业id") @RequestParam("assignmentId") Long assignmentId,
            @ApiParam("要跳转的页数") @RequestParam(name = "pageNo", defaultValue = "1") int pageNo,
            @ApiParam("每页条数，默认：10") @RequestParam(name = "pageSize", defaultValue = "10") int pageSize);
    @GetMapping("/remote/api/assignment/exerciseBook/thumbUp")
    boolean thumbup(@RequestParam("assignmentAnswerId") Long assignmentAnswerId,
                    @RequestParam("isThumbUp") boolean isThumbUp);

    @GetMapping("/remote/api/assignment/exerciseBook/comment/page")
    Page<ApiAssignmentCommentVO> commentPage(
            @RequestParam("assignmentAnswerId") Long assignmentAnswerId,
            @ApiParam("要跳转的页数") @RequestParam(name = "pageNo", defaultValue = "1") int pageNo,
            @ApiParam("每页条数，默认：10") @RequestParam(name = "pageSize", defaultValue = "10") int pageSize);

    @GetMapping("/remote/api/assignment/exerciseBook/comment/add")
    Boolean commentAdd(
            @RequestParam("assignmentAnswerId") Long assignmentAnswerId,
            @RequestParam(name = "parentCommentId", required = false) Long parentCommentId,
            @RequestParam("content") String content);

    @PostMapping("/remote/api/assignment/exerciseBook/tipoff")
    Boolean tipoff(@RequestBody AssignmentAnswerTipoff record);
}
