package com.yizhi.assignment.application.vo;

import com.yizhi.assignment.application.vo.entity.AssignmentFile;
import com.yizhi.assignment.application.vo.entity.AssignmentGrade;
import com.yizhi.assignment.application.vo.entity.AssignmentPoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 新建作业
 *
 * @author wangfeida
 */
@Data
@Api(tags = "AssignmentSaveParamVo", description = "新建作业入参vo类")
public class AssignmentSaveParamVo {

    @ApiModelProperty(name = "style", value = "1是保存 2是修改", required = true)
    private Integer style;

    @ApiModelProperty(name = "id", value = "作业id", required = true)
    private Long id;

    @ApiModelProperty(name = "name", value = "作业名称", required = true)
    private String name;

    @ApiModelProperty(name = "content", value = "作业内容", required = true)
    private String content;

    @ApiModelProperty(name = "finishTime", value = "作业完成时间，如果不限制则不传，如果限制则传 格式2038-01-01 00:00:00", required = false)
    private String finishTime;

    @ApiModelProperty(name = "amendable", value = "是否支持补交(0：否，1：是)，默认是", required = true)
    private Integer amendable;

    @ApiModelProperty(value = "是否启用提醒 1:启用 0：关闭")
    private Integer enableRemind;

    @ApiModelProperty(name = "count", value = "提交次数", required = false)
    private Integer count;

    @ApiModelProperty(name = "visibleRange", value = "可见范围(1：平台用户可见，2：指定学员可见)，默认平台用户可见", required = true)
    private Integer visibleRange;

    @ApiModelProperty(name = "fileUrlList", value = "作业文件url", required = false)
    List<AssignmentFile> fileUrlList;

    @ApiModelProperty(name = "passScore", value = "合格分", required = true)
    private Integer passScore;

    @ApiModelProperty(name = "type", value = "1打分制，2等级制", required = true)
    private Integer type;

    @ApiModelProperty(name = "listGrade", value = "如果type=2等级制度集合,如果是打分，则不写", required = false)
    private List<AssignmentGrade> listGrade;

    @ApiModelProperty(name = "listPoint", value = "可获得积分,沒有设置则不填", required = false)
    private List<AssignmentPoint> listPoint;

    @ApiModelProperty(name = "trainingProjectId", value = "作业所属项目id,前端不传", required = false)
    private Long trainingProjectId;

    @ApiModelProperty(name = "accountId", value = "用户id，前端不传", required = false)
    private Long accountId;

    @ApiModelProperty(name = "accountName", value = "用户名，前端不传", required = false)
    private String accountName;

    @ApiModelProperty(name = "companyId", value = "公司id，前端不传", required = false)
    private Long companyId;

    @ApiModelProperty(name = "siteId", value = "站点id，前端不传", required = false)
    private Long siteId;

    @ApiModelProperty(name = "orgId", value = "组织机构id，前端不传", required = false)
    private Long orgId;

    @ApiModelProperty(value = "各个业务设置提醒时的数据")
    private MessageRemindVo messageRemindVo;

    @ApiModelProperty(notes = "答案字数区间-最小值")
    private Integer answerCharaterNumMin;

    @ApiModelProperty(notes = "答案字数区间-最大值")
    private Integer answerCharaterNumMax;

    @ApiModelProperty(notes = "附件个数区间-最小值")
    private Integer answerAttachmentNumMin;

    @ApiModelProperty(notes = "附件个数区间-最大值")
    private Integer answerAttachmentNumMax;

    @ApiModelProperty(notes = "学员端是否显示评阅结果和评阅状态，0不显示，1显示")
    private Integer showRes;

    @ApiModelProperty(notes = "是否启用作业本，0否，1是")
    private Integer enableExerciseBook;

    @ApiModelProperty(notes = "关键字,逗号分隔")
    private String keywords;

    @ApiModelProperty(notes = "图片")
    private String image;


    @ApiModelProperty(value = "是否启用在日历任务中显示")
    private Integer enableTask;

    @ApiModelProperty(value = "日历任务设置的开始时间")
    private Date taskStartDate;

    @ApiModelProperty(value = "日历任务设置的结束时间")
    private Date taskEndDate;

}
