package com.yizhi.assignment.application.vo.apivo;

import com.yizhi.assignment.application.vo.entity.AssignmentAnswerFile;
import com.yizhi.assignment.application.vo.entity.AssignmentGrade;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
@Api(tags = "ApiAssignmentAnswerCheckVO", description = "单个作业显示")
public class ApiAssignmentAnswerCheckVO {

    @ApiModelProperty(notes = "学生真实姓名")
    private String realName;

    @ApiModelProperty(notes = "答案详情")
    private String content;

    @ApiModelProperty(notes = "作业答案文件信息")
    private List<AssignmentAnswerFile> listAssignmentAnswerFile;

    @ApiModelProperty(notes = "作业成绩")
    private Integer score;

    @ApiModelProperty(notes = "合格分")
    private Integer passScore;


    @ApiModelProperty(notes = "作业评语")
    private String suggestion;

    @ApiModelProperty(notes = "答案反馈文件信息")
    private List<AssignmentAnswerFile> listAssignmentAnswerBackFile;

//    @ApiModelProperty(name = "nextAnswerId", value = "下一个学生提交的作业id")
//    private Long nextAnswerId;
//
//    @ApiModelProperty(name = "prevAnswerId", value = "上一个学生提交的作业id")
//    private Long prevAnswerId;


    /**
     * 下边的这三个字段没用了，以前的需求需要这个代码，现在的需求不需要了，但是前端需调调试bug，因此先添加上
     */

    @ApiModelProperty(notes = "作业地址")
    private List<String> fileUrl;

    @ApiModelProperty(notes = "全部等级")
    private List<AssignmentGrade> grades;

    @ApiModelProperty(notes = "作业等级")
    private String grade;

    @ApiModelProperty(notes = "学员提交作业answerId")
    private List<Long> answerIds;


}
