package com.yizhi.assignment.application.vo.apivo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.baomidou.mybatisplus.annotations.TableField;

/**
 * 学员端作业vo
 *
 * @Author: wangfeida
 * @Date: 2018/09/07 16:40
 */
@Data
@Api(tags = {"学员端作业列表---未完成/已完成列表"}, description = "学员端作业列表---未完成/已完成列表")
public class ApiAssignmentListResultVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    @ApiModelProperty(notes = "作业id")
    private Long id;

    @ApiModelProperty(notes = "作业名称")
    private String assignmentName;
    
    @ApiModelProperty(notes = "所属培训项目名称")
    private String projectName;
    

    @ApiModelProperty(notes = "作业截止时间")
    private Date finishTime;
    

    @ApiModelProperty(notes="分数")
    private Integer score;
    
    
    @ApiModelProperty(notes="等级")
    private String GradeLeval;
    
    
    @ApiModelProperty(notes="1显示分数 2显示等级")
    private Integer isScoreAndGrade;
    
    @ApiModelProperty(notes="是否合格1 合格 2不合格")
    private Integer isPass;
    
    
    @ApiModelProperty(notes="标签")
    private String tag;

    @ApiModelProperty(notes="管理端设置次数")
    private Integer count;
    
    
    @ApiModelProperty(notes="已经提交的次数")
    private Integer submitCount;
    
    
    @ApiModelProperty(notes="是否允许补交amendable是否支持补交(0：否，1：是） ")
    private Integer amendable;
    

    @ApiModelProperty(notes="是否逾期  1没有逾期  2逾期")
    private Integer isOverDue;

    @ApiModelProperty(notes="合格分")
    private Integer passScore;

    
    @ApiModelProperty(value="作业的批阅状态")
    private Integer minAnswerStatus;
    
    @ApiModelProperty(value="作业的批阅状态")
    private Integer maxAnswerStatus;

    @ApiModelProperty(value = "作业的状态")
    private Integer status;


    @ApiModelProperty(value = "作业的要求")
    private String detail;

    @ApiModelProperty(value = "作业操作 1 详情，2 继续提交 3 详情/继续提交 4 无操作")
    private Integer handle;
    
    @ApiModelProperty(value = "学员端是否显示评阅结果和评阅状态，0不显示，1显示")
    private Integer showRes;

    @ApiModelProperty(value = "用户id")
    private Long accountId;

}
