package com.yizhi.assignment.application.vo.apivo;

import com.yizhi.assignment.application.vo.PdfPages;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 作业文件vo
 * 包含作业要求文件和学生提交作业文件
 *
 * @Author: shengchenglong
 * @Date: 2018/3/9 16:18
 */
@Data
@Api(tags = {"作业文件vo"}, description = "包含作业要求文件和学生提交作业文件")
public class ApiFileVo {

    /**
     * 文件名，包含后缀
     */
    @ApiModelProperty(notes = "文件名，包含后缀")
    private String fileName;

    /**
     * 文件后缀
     */
    @ApiModelProperty(notes = "文件后缀")
    private String suffix;

    /**
     * oss URL
     */
    @ApiModelProperty(notes = "oss URL")
    private String ossUrl;

    @ApiModelProperty(notes = "转码后的视屏地址, 标清")
    private String videoSd;

    /**
     * 文件大小
     */
    @ApiModelProperty(notes="文件大小")
    private String size;
    
    @ApiModelProperty(notes="文件上传时间")
    private Date upLoadTime;

    @ApiModelProperty(notes = "是否是视屏文件")
    private boolean isVideo;

    @ApiModelProperty(notes = "如果该值不为空字符串,显示出来,视屏正在处理,暂时看不了;如果为空字符串,则视屏可观看")
    private String state;
    
    @ApiModelProperty(notes = "作业文件id")
    private Long id;
    
    private List<PdfPages> pdfPages;
}
