package com.yizhi.assignment.application.vo.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 作业答案 - 评论
 * </p>
 *
 * @author shengchenglong123
 * @since 2019-10-22
 */
@Data
@Api(tags = "AssignmentComment", description = "作业答案 - 评论")
@TableName("assignment_comment")
public class AssignmentComment extends Model<AssignmentComment> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "作业答案id")
    @TableField("assignment_answer_id")
    private Long assignmentAnswerId;

    @ApiModelProperty(value = "评论内容")
    private String content;

    @ApiModelProperty(value = "审核状态：0通过，1下架（默认通过）")
    @TableField("audit_status")
    private Integer auditStatus;

    @ApiModelProperty(value = "下架人id")
    @TableField("auditor_id")
    private Long auditorId;

    @ApiModelProperty(value = "下架意见")
    @TableField("audit_content")
    private String auditContent;

    @ApiModelProperty(value = "下架时间")
    @TableField("auditor_time")
    private Date auditorTime;

    @ApiModelProperty(value = "创建者id")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建者名称")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "父评论的id（该评论是对父评论的评论）")
    @TableField("parent_id")
    private Long parentId;

    @ApiModelProperty(value = "父评论创建者名称")
    @TableField("parent_create_by_name")
    private String parentCreateByName;

    @ApiModelProperty(value = "父评论创建者id")
    @TableField("parent_create_by_id")
    private Long parentCreateById;

    @ApiModelProperty(value = "站点id")
    @TableField("site_id")
    private Long siteId;

    @ApiModelProperty(value = "组织id")
    @TableField("org_id")
    private Long orgId;

    @ApiModelProperty(value = "企业id")
    @TableField("company_id")
    private Long companyId;

    @ApiModelProperty(value = "用户头像")
    @TableField("user_avatar")
    private String userAvatar;

//    @ApiModelProperty("0上架，1下架")
//    private Integer status;

    @ApiModelProperty("0未删除,1已删除")
    private Integer deleted;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
