package com.yizhi.assignment.application.vo.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 老师布置的作业对应多个文件，存放多个文件地址
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
@Data
@Api(tags = "AssignmentFile", description = "老师布置的作业对应多个文件，存放多个文件地址")
@TableName("assignment_file")
public class AssignmentFile extends Model<AssignmentFile> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(notes = "id主键,前端不输入，后台生成")
    private Long id;

    @ApiModelProperty(notes = "布置的作业id,前端不输入，后台生成")
    @TableField("assignment_id")
    private Long assignmentId;

    @ApiModelProperty(notes = "文件存放路径",required=true)
    @TableField("file_url")
    private String fileUrl;

    @ApiModelProperty(notes = "源文件名。例如：作业1",required=true)
    @TableField("file_name")
    private String fileName;

    @ApiModelProperty(notes = "后缀名。例如：.doc/.ppt",required=true)
    private String suffix;
    
    /**
     * 文件大小
     */
    @ApiModelProperty(notes="文件大小",required=true)
    private String size;

    @ApiModelProperty(notes = "创建人id,前端不输入，后台生成")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(notes = "创建人姓名,前端不输入，后台生成")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(notes = "创建时间,前端不输入，后台生成")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
