package com.yizhi.application.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 老师布置的作业对应多个文件，存放多个文件地址
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
@Data

@TableName("assignment_file")
public class AssignmentFile extends Model<AssignmentFile> {

    private static final long serialVersionUID = 1L;


    
    private Long id;

    
    @TableField("assignment_id")
    private Long assignmentId;

    
    @TableField("file_url")
    private String fileUrl;

    
    @TableField("file_name")
    private String fileName;

    
    private String suffix;
    
    /**
     * 文件大小
     */
    
    private String size;

    
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
