package com.yizhi.application.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 老师布置的作业等级
 * 编号100号作业 可以有多个等级
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
@Data

@TableName("assignment_grade")
public class AssignmentGrade extends Model<AssignmentGrade> {

    private static final long serialVersionUID = 1L;


    
    private Long id;

    
    @TableField("assignment_id")
    private Long assignmentId;

    
    
    @TableField("min_score")
    private String minScore;
    
    
    
    @TableField("max_score")
    private String maxScore;
    
    
    
    @TableField("description")
    private String description;

    
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;



    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
