package com.yizhi.application.mapper;

import java.util.List;

import com.yizhi.application.entity.AssignmentAnswerFile;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.assignment.application.vo.apivo.ApiFileVo;

/**
 * <p>
 * 学员对作业回复可以是文件，存放学员的作业回复的文件的地址 Mapper 接口
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
public interface AssignmentAnswerFileMapper extends BaseMapper<AssignmentAnswerFile> {
	
	
	/**
	 * 根据type类型找到对应的答案文件或者回复文件
	 * @param answerId
	 * @param type
	 * @return
	 */
	List<ApiFileVo> listAssignmentAnswerFile(@Param("answerId")Long answerId,@Param("type")Integer type);

	/**
	 * 确认文件是视屏文件
	 * @param ids
	 * @return
	 */
	Integer verifyVideo(@Param("ids") List<Long> ids);

}
