package com.yizhi.application.mapper;

import com.yizhi.application.entity.AssignmentStudent;
import com.yizhi.assignment.application.vo.apivo.ApiAssignmentListResultVO;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;

/**
 * <p>
 * 老师布置作业和学生进行关联。
多对多的关系。
一个老师布置的作业有多个学生做。 Mapper 接口
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
public interface AssignmentStudentMapper extends BaseMapper<AssignmentStudent> {
	
	/**
	 * 分配給此人的 作业id  已经去重
	 * @param relationIds
	 * @return
	 */
	List<Long> getAssignmentIdsByAccountId(@Param("relationIds")List<Long> relationIds,@Param("siteId")Long siteId,Page<Long> page);
	
	
	
	
	/**
	 * 分配給此人的 作业id  已经去重 进行中/已结束             学员端----2018/09/08
	 * @param relationIds
	 * @param siteId
	 * @param curDate
	 * @param Type
	 * @param page
	 * @return
	 */
	List<Long> listUnFinishIds(@Param("relationIds")List<Long> relationIds,@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountId")Long accountId,Page<Long> page);

	List<ApiAssignmentListResultVO> listUnfinish(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountId")Long accountId,@Param("assignmentIds")List<Long> assignmentIds );
	
	List<Long> listFinishIds(@Param("relationIds")List<Long> relationIds,@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountId")Long accountId,Page<Long> pageLimit);
	
	List<ApiAssignmentListResultVO> listFinish(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountId")Long accountId,@Param("assignmentIds")List<Long> assignmentIds );
	/**
	 * 根据名字搜索此人全部列表                                         学员端-------2018/09/08
	 * @param name
	 * @param relationIds
	 * @param siteId
	 * @param page
	 * @return
	 */
	List<Long> myAllListByName(@Param("name")String name,@Param("relationIds")List<Long> relationIds,@Param("siteId")Long siteId,Page<Long> page);
	
	
	
	/**
	 * 分发给此人的作业数量  目录页面                                学员端-------2018/09/08
	 * @param name
	 * @param relationIds
	 * @param siteId
	 * @return
	 */
	Integer myAllListNum(@Param("relationIds")List<Long> relationIds,@Param("siteId")Long siteId);

	List<Long> getUsefulIds(@Param("ids") List<Long> ids,
							@Param("relationIds") List<Long> relationIds,
							@Param("siteId") Long siteId);
	
	Integer maxGradeByAccountId(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountId")Long accountId,@Param("assignmentId")Long assignmentId);
}
