package com.yizhi.application.service.impl;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.entity.*;
import com.yizhi.application.eum.AnswerFileTypeEnum;
import com.yizhi.application.mapper.*;
import com.yizhi.application.orm.hierarchicalauthorization.HQueryUtil;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.application.orm.util.QueryUtil;
import com.yizhi.application.service.*;
import com.yizhi.application.util.AssignmentEvenSendMessage;
import com.yizhi.assignment.application.vo.*;
import com.yizhi.assignment.application.vo.apivo.*;
import com.yizhi.assignment.application.vo.enums.AssignmentConstant;
import com.yizhi.assignment.application.vo.enums.AssignmentHandleConstant;
import com.yizhi.assignment.application.vo.enums.EvenType;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.core.application.enums.TaskParamsEnums;
import com.yizhi.core.application.event.EventWrapper;
import com.yizhi.core.application.publish.CloudEventPublisher;
import com.yizhi.core.application.task.AbstractTaskHandler;
import com.yizhi.core.application.task.TaskExecutor;
import com.yizhi.core.application.vo.DroolsVo;
import com.yizhi.system.application.system.remote.AuthClient;
import com.yizhi.util.application.clazz.ClassUtil;
import com.yizhi.util.application.constant.QueueConstant;
import com.yizhi.util.application.constant.TpActivityType;
import com.yizhi.util.application.enums.i18n.ButtonStatus;
import com.yizhi.util.application.event.TrainingProjectEvent;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestBody;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;


/**
 * <p>
 * 老师布置作业的主表 服务实现类
 * </p>
 *
 * @author 王飞达123
 * @since 2018-03-08
 */
@Service
@Transactional
public class AssignmentServiceImpl extends ServiceImpl<AssignmentMapper, Assignment> implements AssignmentService {


    private static final Logger LOG = LoggerFactory.getLogger(AssignmentServiceImpl.class);

    @Autowired
    private AssignmentMapper assignmentMapper;
    @Autowired
    private AssignmentFileMapper assignmentFileMapper;
    @Autowired
    private AssignmentGradeService assignmentGradeService;
    @Autowired
    private AssignmentContentMapper assignmentContentMapper;
    @Autowired
    private AssignmentAnswerMapper assignmentAnswerMapper;
    @Autowired
    private AssignmentAnswerService assignmentAnswerService;
    @Autowired
    private AssignmentFileService assignmentFileService;
    @Autowired
    private AssignmentAnswerSuggestionService assignmentAnswerSuggestionService;
    @Autowired
    private AssignmentAnswerFileService assignmentAnswerFileService;
    @Autowired
    private AssignmentStudentService assignmentStudentService;
    @Autowired
    private AssignmentPointService assignmentPointService;
    @Autowired
    private AssignmentStudentMapper assignmentStudentMapper;
    @Autowired
    private TaskExecutor taskExecutor;
    @Autowired
    private CloudEventPublisher cloudEventPublisher;
    @Autowired
    private AssignmentAuditorService assignmentAuditorService;
    @Autowired
    private AssignmentContentService assignmentContentService;
    @Autowired
    private IdGenerator id; // 主键生成器
    @Autowired
    private AssignmentPointMapper assignmentPointMapper;
    @Autowired
    private AssignmentGradeMapper assignmentGradeMapper;

    @Autowired
    private AssignmentEvenSendMessage assignmentEvenSendMessage;

    @Transactional
    public Boolean save(@RequestBody AssignmentSaveParamVo assignmentVo) {
        // TODO Auto-generated method stub
        if (assignmentVo.getFinishTime() == null) {
            assignmentVo.setFinishTime("2038-01-01 23:59:59");
        }
        SimpleDateFormat sdm = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date dateFormate = null;
        try {
            dateFormate = sdm.parse(assignmentVo.getFinishTime() + " 23:59:59");
        } catch (ParseException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        Date date = new Date();
        Assignment assignment = new Assignment();

        // 2019-10-16
        assignment.setAnswerAttachmentNumMax(assignmentVo.getAnswerAttachmentNumMax());
        assignment.setAnswerAttachmentNumMin(assignmentVo.getAnswerAttachmentNumMin());
        assignment.setAnswerCharaterNumMax(assignmentVo.getAnswerCharaterNumMax());
        assignment.setAnswerCharaterNumMin(assignmentVo.getAnswerCharaterNumMin());
        assignment.setEnableExerciseBook(assignmentVo.getEnableExerciseBook());
        assignment.setShowRes(assignmentVo.getShowRes());
        assignment.setKeywords(assignmentVo.getKeywords());
        assignment.setImage(assignmentVo.getImage());

        assignment.setId(assignmentVo.getId());                               // 主键
        assignment.setSerialNum(id.generate());                               // 作业序号
        assignment.setName(assignmentVo.getName());                           // 项目名字
        assignment.setAmendable(assignmentVo.getAmendable());                 // 是否支持补交 0代表不支持
        assignment.setVisibleRange(assignmentVo.getVisibleRange());           // 支持的可见范围 可见范围(1：平台用户可见，2：指定学员可见)，默认平台用户可见
        assignment.setType(assignmentVo.getType());
        assignment.setFinishTime(dateFormate);
        assignment.setStatus(1);                                   // 新建作业默认状态是草稿状态
        assignment.setCount(assignmentVo.getCount());
        assignment.setEnableRemind(assignmentVo.getEnableRemind());
        assignment.setPassScore(assignmentVo.getPassScore());

        assignment.setCompanyId(assignmentVo.getCompanyId());
        assignment.setSiteId(assignmentVo.getSiteId());
        assignment.setOrgId(assignmentVo.getOrgId());

        assignment.setEnableTask(assignmentVo.getEnableTask());
        if (null != assignmentVo.getEnableTask() && assignmentVo.getEnableTask() == 1) {
            assignment.setTaskStartDate(assignmentVo.getTaskStartDate());
            assignment.setTaskEndDate(assignmentVo.getTaskEndDate());
        }

        if (assignmentVo.getStyle() == 1) {

            assignment.setCreateById(assignmentVo.getAccountId());
            assignment.setCreateByName(assignmentVo.getAccountName());
            assignment.setCreateTime(date);
            Integer insert = assignmentMapper.insert(assignment);// 作业名字保存
            if (insert > 0) {
                LOG.info("是否开启提醒：" + assignmentVo.getEnableRemind());
                if (assignment != null && assignmentVo.getEnableRemind() == 1) {
                    //保存作业提醒
                    RequestContext context = ContextHolder.get();
                    try {
                        taskExecutor.asynExecute(new AbstractTaskHandler() {
                            @Override
                            public void handle() {
                                assignmentEvenSendMessage.systemSendMessage(assignment, assignmentVo.getMessageRemindVo(), context);
                            }
                        });
                    } catch (Exception e) {
                        e.printStackTrace();
                        LOG.info("作业发消息异常");
                    }
                }
            }
        }
        if (assignmentVo.getStyle() == 2) {
            assignment.setUpdateById(assignmentVo.getAccountId());
            assignment.setUpdateByName(assignmentVo.getAccountName());
            assignment.setUpdateTime(date);
            Integer integer = assignmentMapper.updateById(assignment);//作业修改
            if (integer > 0) {
                LOG.info("是否开启提醒：" + assignmentVo.getEnableRemind());
                if (assignment != null) {
                    //保存作业提醒
                    RequestContext context = ContextHolder.get();
                    try {
                        taskExecutor.asynExecute(new AbstractTaskHandler() {
                            @Override
                            public void handle() {
                                assignmentEvenSendMessage.systemSendMessage(assignment, assignmentVo.getMessageRemindVo(), context);
                            }
                        });
                    } catch (Exception e) {
                        e.printStackTrace();
                        LOG.info("作业发消息异常");
                    }
                }
            }
// 处理删除数值的情况
            assignmentMapper.updateNum(assignment);
        }

        // 判断老师布置的作业内容是否为空
        if (StringUtils.isNotEmpty(assignmentVo.getContent())) {
            if (assignmentVo.getStyle() == 1) {   //保存
                AssignmentContent assignmentContent = new AssignmentContent();
                assignmentContent.setId(id.generate());
                assignmentContent.setAssignmentId(assignmentVo.getId());
                assignmentContent.setComment(assignmentVo.getContent());
                assignmentContent.setCreateById(assignmentVo.getAccountId());
                assignmentContent.setCreateByName(assignmentVo.getAccountName());
                assignmentContent.setCreateTime(date);
                assignmentContentMapper.insert(assignmentContent);
            }
            if (assignmentVo.getStyle() == 2) {    //修改
                //修改的内容
                AssignmentContent assignmentContent = new AssignmentContent();
                assignmentContent.setComment(assignmentVo.getContent());
                assignmentContent.setUpdateById(assignmentVo.getAccountId());
                assignmentContent.setUpdateByName(assignmentVo.getAccountName());
                assignmentContent.setUpdateTime(date);
                //修改的条件
                AssignmentContent assignmentContent2 = new AssignmentContent();
                assignmentContent2.setAssignmentId(assignmentVo.getId());
                assignmentContentMapper.update(assignmentContent, new EntityWrapper<AssignmentContent>(assignmentContent2));
            }
        }

        if (assignmentVo.getStyle() == 2) {  //修改
            //先删除原来的文件，再增加新的文件
            assignmentFileService.deleteFileByAssignmentId(assignmentVo.getId());
        }

        AssignmentFile assignmentFile = null; // 布置的作业对应的文件
        if (!CollectionUtils.isEmpty(assignmentVo.getFileUrlList())) {
            for (int i = 0; i < assignmentVo.getFileUrlList().size(); i++) {
                assignmentFile = new AssignmentFile();
                assignmentFile.setId(id.generate()); // 主键id
                assignmentFile.setAssignmentId(assignmentVo.getId());
                assignmentFile.setFileUrl(assignmentVo.getFileUrlList().get(i).getFileUrl());
                assignmentFile.setFileName(assignmentVo.getFileUrlList().get(i).getFileName());
                assignmentFile.setSuffix(assignmentVo.getFileUrlList().get(i).getSuffix());
                assignmentFile.setSize(assignmentVo.getFileUrlList().get(i).getSize());
                assignmentFile.setCreateById(assignmentVo.getAccountId());
                assignmentFile.setCreateByName(assignmentVo.getAccountName());
                assignmentFile.setCreateTime(date);
                assignmentFileMapper.insert(assignmentFile);
            }
        }
        /**
         * 设置评阅人
         */
        if (assignmentVo.getStyle() == 1) {
            AssignmentAuditor auditor = new AssignmentAuditor();
            auditor.setAssignmentId(id.generate());
            auditor.setAssignmentId(assignmentVo.getId());
            auditor.setAccountId(assignmentVo.getAccountId());
            auditor.setCreateById(assignmentVo.getAccountId());
            auditor.setCreateByName(assignmentVo.getAccountName());
            auditor.setCreateTime(date);
            assignmentAuditorService.insert(auditor);

        }

        /**
         * 设置等级制度
         */
        // 保存---等級    直接添加
        if (assignmentVo.getStyle() == 1 && assignmentVo.getType() == 2 && assignmentVo.getListGrade().size() > 0) {
            AssignmentGrade assignmentGrade = null;
            for (int i = 0; i < assignmentVo.getListGrade().size(); i++) {
                assignmentGrade = new AssignmentGrade();

                com.yizhi.assignment.application.vo.entity.AssignmentGrade assignmentGradeVO = assignmentVo.getListGrade().get(i);
                BeanUtils.copyProperties(assignmentGradeVO, assignmentGrade);
                //assignmentGrade = assignmentVo.getListGrade().get(i);
                assignmentGrade.setId(id.generate());
                assignmentGrade.setAssignmentId(assignmentVo.getId());
                assignmentGrade.setCreateById(assignmentVo.getAccountId());
                assignmentGrade.setCreateByName(assignmentVo.getAccountName());
                assignmentGrade.setCreateTime(date);
                assignmentGradeService.insert(assignmentGrade);
            }
        }
        // 修改为打分  不管是否有等级都删除
        if (assignmentVo.getStyle() == 2 && assignmentVo.getType() == 1) {
            assignmentGradeService.deleteAssignmentGradeByAssignmentId(assignmentVo.getId());
        }

        // 修改为等级  先删除原来的等级，再添加新的等级

        if (assignmentVo.getStyle() == 2 && assignmentVo.getType() == 2) {
            assignmentGradeService.deleteAssignmentGradeByAssignmentId(assignmentVo.getId());
            if (CollectionUtils.isNotEmpty(assignmentVo.getListGrade())) {
                AssignmentGrade assignmentGrade = null;
                for (int i = 0; i < assignmentVo.getListGrade().size(); i++) {
                    assignmentGrade = new AssignmentGrade();

                    com.yizhi.assignment.application.vo.entity.AssignmentGrade assignmentGradeVO = assignmentVo.getListGrade().get(i);
                    BeanUtils.copyProperties(assignmentGradeVO, assignmentGrade);

                    //assignmentGrade = assignmentVo.getListGrade().get(i);
                    if (assignmentGrade.getMinScore() == null || assignmentGrade.getMaxScore() == null || assignmentGrade.getDescription() == null) {
                        continue;
                    }
                    assignmentGrade.setId(id.generate());
                    assignmentGrade.setAssignmentId(assignmentVo.getId());
                    assignmentGrade.setMinScore(assignmentGrade.getMinScore());
                    assignmentGrade.setMaxScore(assignmentGrade.getMaxScore());
                    assignmentGrade.setDescription(assignmentGrade.getDescription());
                    assignmentGrade.setCreateById(assignmentVo.getAccountId());
                    assignmentGrade.setCreateByName(assignmentVo.getAccountName());
                    assignmentGrade.setCreateTime(date);
                    assignmentGradeService.insert(assignmentGrade);
                }
            }
        }


        /**
         * 设置积分
         */
        assignmentPointService.deleteAssignmentPointByAssignmentId(assignmentVo.getId());
        if (CollectionUtils.isNotEmpty(assignmentVo.getListPoint())) {
            AssignmentPoint assignmentPoint = new AssignmentPoint();
            for (int i = 0; i < assignmentVo.getListPoint().size(); i++) {

                com.yizhi.assignment.application.vo.entity.AssignmentPoint assignmentPointVO = assignmentVo.getListPoint().get(i);
                BeanUtils.copyProperties(assignmentPointVO, assignmentPoint);

                //assignmentPoint = assignmentVo.getListPoint().get(i);
                if (assignmentPoint.getMinScore() == null || assignmentPoint.getMaxScore() == null || assignmentPoint.getPoint() == null) {
                    continue;
                }
                assignmentPoint.setId(id.generate());
                assignmentPoint.setAssignmentId(assignmentVo.getId());
                assignmentPoint.setMinScore(assignmentPoint.getMinScore());
                assignmentPoint.setMaxScore(assignmentPoint.getMaxScore());
                assignmentPoint.setPoint(assignmentPoint.getPoint());
                assignmentPoint.setCreateById(assignmentVo.getAccountId());
                assignmentPoint.setCreateByName(assignmentVo.getAccountName());
                assignmentPoint.setCreateTime(date);
                assignmentPointService.insert(assignmentPoint);
            }
        }
        return true;
    }

    /**
     * 管理端显示作业列表(投票只查询上架的)---
     * <p>
     * source=0作业直接进来的  要草稿上架下架
     * source=1  培训项目进来的   上架  training_project_id=0 training_project_name=null
     * status!=null&& status=1   投票來的
     */
    @Autowired
    AuthClient authClient;

    public Page<Assignment> assignmentList(String currentTime, AssignmentListVoTo assignmentListVoTo) {
        RequestContext context = ContextHolder.get();
//        List<Long> adminIds = authClient.getAdminIdsByAccountId(context.getCompanyId(), context.getSiteId(), context.getAccountId());
        List<Long> adminIds = context.getManagerIds();
        Date curDate = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String dateString = sdf.format(curDate);       //将Date类型转换成String类型

        Integer pageNo = assignmentListVoTo.getPageNo();
        Integer pageSize = assignmentListVoTo.getPageSize();
        String name = assignmentListVoTo.getName();
        Integer source = assignmentListVoTo.getSource();//0作业直接进来的  1 培训项目进来的  2投票进来的
//        List<Long> orgIds = assignmentListVoTo.getOrgIds();
//        Long companyId = assignmentListVoTo.getCompanyId();
//        Long siteId = assignmentListVoTo.getSiteId();
        //培训项目过滤所需  胡涛写

      /* String date = null;
       if(StringUtils.isNotBlank(currentTime)){

       	SimpleDateFormat a = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
       	Long temp = Long.valueOf(currentTime);
       	date = a.format(temp);

	   }*/
        boolean isAdmin = context.isAdmin();
        Integer admin = isAdmin ? 1 : 0;
        Page<Assignment> page = new Page<Assignment>(pageNo, pageSize);
//        HQueryUtil.startHQ(Assignment.class);
        List<Assignment> list = assignmentMapper.getAssignmentListByManager(context.getAccountId(), admin, name,
                dateString, context.getCompanyId(), context.getSiteId(), source, adminIds, page);
        page.setRecords(list);
        return page;
    }

    /**
     * 待阅读数量
     */
    public Integer noRead(Long assignmentId) {
        // TODO Auto-generated method stub
        AssignmentAnswer assignmentAnswer = new AssignmentAnswer();
        assignmentAnswer.setAssignmentId(assignmentId);
        return assignmentAnswerMapper.selectCount(new EntityWrapper<AssignmentAnswer>(assignmentAnswer));
    }


    /**
     * 管理端删除作业
     */
    public Boolean updateDelete(AssignmentDeleteVO updateDelete) {
        // TODO Auto-generated method stub
        Assignment assignment = new Assignment();
        assignment.setId(updateDelete.getAssignmentId());
        assignment.setStatus(0); //0代表被删除
        assignment.setAddedTime(null);
        assignment.setUpdateById(updateDelete.getAccountId());
        assignment.setUpdateByName(updateDelete.getAccountName());
        assignment.setUpdateTime(new Date());
        return assignmentMapper.updateById(assignment) > 0;
    }



/*	@Override
	public Page<ApiAssignmentListResultVO> listUnfinishedAssignment(int pageNo, int pageSize,Long accountId,List<Long> relationIds,Long siteId) {
	    //查出来哪些作业此人的答案已经达到上限的(作业在上架状态)
		List<Long> listOverLimit=assignmentMapper.getIsOverVO(accountId,siteId);
		//分配给此人的作业idList
		Page<Long> pageLimit = new Page<Long>(pageNo, pageSize);
		Date date=new Date();
		SimpleDateFormat simpleDateFormat=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String curDate=simpleDateFormat.format(date);
		//listOverLimit  作业id不在这个范围的
		List<Long> assignmentIds=assignmentStudentMapper.isOverList(relationIds, siteId, curDate, 1,listOverLimit, pageLimit);
		//装数据
		List<ApiAssignmentListResultVO> listApiAssignmentListResultVO=new ArrayList<ApiAssignmentListResultVO>();
		Page<ApiAssignmentListResultVO> pageRecords=new Page<ApiAssignmentListResultVO>();
		
		//组装数据
		if(assignmentIds!=null && assignmentIds.size()>0) {
			for (int i = 0; i < assignmentIds.size(); i++) {
				//对某一份作业进行组装
				ApiAssignmentListResultVO aalrv=new ApiAssignmentListResultVO();
				Long assignmentId=assignmentIds.get(i);
				List<AssignmentAnswer> listAnswer=assignmentAnswerService.listAssignmentAnswerByAssignmentIdAndAccountId(assignmentId, accountId);
				Assignment assignment=assignmentMapper.selectById(assignmentId);
				//初始化 合格分数
                Integer passScore = null;
				if(assignment!=null) {
                    // 合格分数
                     passScore = assignment.getPassScore();
					aalrv.setId(assignmentId);
					aalrv.setAssignmentName(assignment.getName());
					aalrv.setProjectName(assignment.getTrainingProjectName());
					aalrv.setFinishTime(assignment.getFinishTime());
					aalrv.setAmendable(assignment.getAmendable());
					aalrv.setCount(assignment.getCount());
					aalrv.setSubmitCount(listAnswer==null?0:listAnswer.size());
					aalrv.setIsOverDue(1);
					aalrv.setPassScore(passScore);
                    AssignmentContent assignmentContent = new AssignmentContent();
                    assignmentContent.setAssignmentId(assignmentId);

                    try {
                        assignmentContent = assignmentContentService.selectOne(QueryUtil.condition(assignmentContent));
                        aalrv.setDetail(assignmentContent.getComment());
                    } catch (Exception e) {
                        LOG.info("error{}",e);
                    }

				}

				//学员也提交了但是未被评阅
				if(listAnswer!=null&&listAnswer.size()>0) {
					boolean tag=false;
					for (int j = 0; j < listAnswer.size(); j++) {
					    // 答案存在状态为2 表示已经批阅
						if(listAnswer.get(j).getStatus()==2) {
							tag=false;
                            Integer answerScore = listAnswer.get(j).getScore();

                            if (answerScore.compareTo(passScore)>=0) {
                                aalrv.setStatus(AssignmentConstant.PASS.getCode());
                            } else {
                                aalrv.setStatus(AssignmentConstant.NO_PASS.getCode());
                            }


                            continue;
						}
						if(listAnswer.get(j).getStatus()==1) {
							tag=true;
							break;
						}
					}
					if(tag) {
						aalrv.setTag("待评阅");
						aalrv.setStatus(AssignmentConstant.MARKING.getCode());
						// pc 列表展示
//                        if(assignment.getAmendable()==1){
                            if (assignment.getCount()-listAnswer.size()>0) {
                                aalrv.setHandle(AssignmentHandleConstant.CONTINUEDETAIL.getCode());
                            } else {
                                aalrv.setHandle(AssignmentHandleConstant.DETAIL.getCode());
                            }
//                        } else {
//                            aalrv.setHandle(AssignmentHandleConstant.DETAIL.getCode());
//                        }
					}
					
					//全部已经被评阅
					if(!tag) {
					    //获取作业得到的最大分数对象
						AssignmentAnswer assignmentAnswer=assignmentAnswerMapper.maxGradeByAccountIdAndAssignmentId(accountId, assignmentId);
						// 初始化最大分数
						Integer maxGrade=null;
					    if(assignmentAnswer!=null) {
					    	maxGrade=assignmentAnswer.getScore();
                            int compareResult = maxGrade.compareTo(passScore);
                            if (compareResult<0){
                                // 小于合格分
                                aalrv.setStatus(AssignmentConstant.NO_PASS.getCode());
                            } else {
                                aalrv.setStatus(AssignmentConstant.PASS.getCode());
                            }
					    }
					    // 获取作业答案的分数等级
						AssignmentGrade assignmentGrade=assignmentGradeMapper.getGradeByAssignmentIdAndScore(assignmentId, maxGrade);

					    if(assignmentGrade!=null) {
					        // 组装等级到对象中
				    		aalrv.setGradeLeval(assignmentGrade.getDescription());
				    	}
				    	// 当前答案显示等级值/分数值
						if(assignment!=null) {
							aalrv.setIsScoreAndGrade(assignment.getType());
						}
						aalrv.setScore(maxGrade);
					    // pc操作里
                        if(assignment.getAmendable()==1){
                            if (assignment.getCount()-listAnswer.size()>0) {
                                aalrv.setHandle(AssignmentHandleConstant.CONTINUEDETAIL.getCode());
                            } else {
                                aalrv.setHandle(AssignmentHandleConstant.DETAIL.getCode());
                            }
                        } else {
                            aalrv.setHandle(AssignmentHandleConstant.DETAIL.getCode());
                        }
					}
				} else {
				    // 未提交
                    aalrv.setTag("待提交");
                    aalrv.setStatus(AssignmentConstant.SUBMISSION.getCode());
                    aalrv.setHandle(AssignmentHandleConstant.SUBMIT.getCode());
                }
				listApiAssignmentListResultVO.add(aalrv);
			}
		}
		pageRecords.setRecords(listApiAssignmentListResultVO);
		pageRecords.setTotal(pageLimit.getTotal());
		return pageRecords;
	}*/


    @Override
    public Page<ApiAssignmentListResultVO> listAllAssignmentByName(String name, int pageNo, int pageSize, Long accountId, List<Long> relationIds, Long siteId) {
        // TODO Auto-generated method stub
        List<ApiAssignmentListResultVO> listApiAssignmentListResultVO = new ArrayList<ApiAssignmentListResultVO>();
        Page<ApiAssignmentListResultVO> page = new Page<ApiAssignmentListResultVO>(pageNo, pageSize);
        //分配给此人的作业idList
        Page<Long> pageLimit = new Page<Long>(pageNo, pageSize);
        Date date = new Date();
        List<Long> assignmentIds = assignmentStudentMapper.myAllListByName(name, relationIds, siteId, pageLimit);
        if (assignmentIds != null && assignmentIds.size() > 0) {
            for (int i = 0; i < assignmentIds.size(); i++) {
                //对某一份作业进行组装

                ApiAssignmentListResultVO aalrv = new ApiAssignmentListResultVO();
                Long assignmentId = assignmentIds.get(i);
                List<AssignmentAnswer> listAnswer = assignmentAnswerService.listAssignmentAnswerByAssignmentIdAndAccountId(assignmentId, accountId);
                Assignment assignment = assignmentMapper.selectById(assignmentId);
                boolean isYq = false;
                if (assignment != null) {
                    aalrv.setId(assignmentId);
                    aalrv.setAssignmentName(assignment.getName());
                    aalrv.setProjectName(assignment.getTrainingProjectName());
                    aalrv.setFinishTime(assignment.getFinishTime());
                    aalrv.setAmendable(assignment.getAmendable());
                    aalrv.setCount(assignment.getCount());
                    aalrv.setPassScore(assignment.getPassScore());
                    aalrv.setSubmitCount(listAnswer == null ? 0 : listAnswer.size());
                    isYq = assignment.getFinishTime().compareTo(date) < 0;

                    AssignmentContent assignmentContent = new AssignmentContent();
                    assignmentContent.setAssignmentId(assignmentId);
                    try {
                        assignmentContent = assignmentContentService.selectOne(QueryUtil.condition(assignmentContent));
                        aalrv.setDetail(assignmentContent.getComment());
                    } catch (Exception e) {
                        LOG.info("error{}", e);
                    }
                }


                if (isYq) {
                    aalrv.setIsOverDue(2);
                }
                if (!isYq) {
                    aalrv.setIsOverDue(1);
                }
                //未提交  逾期
                if (listAnswer == null && isYq) {
                    aalrv.setTag("已逾期");
                }


                if (listAnswer != null && listAnswer.size() > 0) {
                    boolean tag = false;
                    for (int j = 0; j < listAnswer.size(); j++) {
                        if (listAnswer.get(j).getStatus() == 2) {   //已阅
                            tag = false;
                            continue;
                        }
                        if (listAnswer.get(j).getStatus() == 1) {
                            tag = true;
                            break;
                        }
                    }
                    if (tag) {
                        aalrv.setTag("评阅中");
                    }
                    if (!tag) {
                        AssignmentAnswer assignmentAnswer = assignmentAnswerMapper.maxGradeByAccountIdAndAssignmentId(accountId, assignmentId);
                        Integer maxGrade = null;
                        if (assignmentAnswer != null) {
                            maxGrade = assignmentAnswer.getScore();
                        }
                        AssignmentGrade assignmentGrade = assignmentGradeMapper.getGradeByAssignmentIdAndScore(assignmentId, maxGrade);
                        if (maxGrade.compareTo(assignment.getPassScore()) >= 0) {
                            //aalrv.setTag("已提交已完成");
                            aalrv.setScore(maxGrade);

                            if (assignmentGrade != null) {
                                aalrv.setGradeLeval(assignmentGrade.getDescription());
                            }
                            if (assignment != null) {
                                aalrv.setIsScoreAndGrade(assignment.getType());
                            }
                            aalrv.setIsPass(1);
                        } else {
                            //aalrv.setTag("已提交未完成");
                            aalrv.setScore(maxGrade);
                            if (assignmentGrade != null) {
                                aalrv.setGradeLeval(assignmentGrade.getDescription());
                            }
                            if (assignment != null) {
                                aalrv.setIsScoreAndGrade(assignment.getType());
                            }
                            aalrv.setIsPass(2);
                        }
                    }
                    listApiAssignmentListResultVO.add(aalrv);
                }
            }
        }
        page.setRecords(listApiAssignmentListResultVO);
        page.setTotal(pageLimit.getTotal());
        return page;

    }

    @Override
    public Boolean update(Long id, Integer status, Long accountId, String accountName) {
        Assignment m = new Assignment();
        Date date = new Date();
        Integer statue = null;
        if (status == 2) { //上架变成下架
            statue = 3;
            m.setAddedTime(null);
        } else if (status == 3 || status == 1) {//草稿或者下架转换为上架
            statue = 2;
            m.setAddedTime(date);
        }
        m.setStatus(statue);
        m.setId(id);
        m.setUpdateById(accountId);
        m.setUpdateByName(accountName);
        m.setUpdateTime(date);
        Integer update = assignmentMapper.updateById(m);
        if (update > 0) {
            Assignment assignment = this.selectById(id);
            RequestContext context = ContextHolder.get();
            if (assignment.getEnableRemind() == 1) {
                try {
                    //发消息告知业务状态有变化
                    MessageRemindVo remindVo = new MessageRemindVo();
                    remindVo.setTaskStatusUpdate(true);
                    taskExecutor.asynExecute(new AbstractTaskHandler() {
                        @Override
                        public void handle() {
                            assignmentEvenSendMessage.systemSendMessage(assignment, remindVo, context);
                        }
                    });
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
        return update > 0;

    }

	/*@Override
	public Integer sumNum(String name,Long siteId) {
		// TODO Auto-generated method stub
		Assignment assignment=new Assignment();
	    assignment.setSiteId(siteId);
		EntityWrapper<Assignment> wrapper=new EntityWrapper<Assignment>(assignment);
		if(StringUtils.isNotEmpty(name)) {
			wrapper.like("name", name);
		}
		return this.selectCount(wrapper);
	}*/

    @Override
    public Integer selectAssignmentNumByAccountId(Long accountId) {
        // TODO Auto-generated method stub
        return assignmentMapper.selectAssignmentNumByAccountId(accountId);
    }

    @Transactional
    @Override
    public PointParamVO assignmentReadOverByTeacher(AssignmentAnswerContentVO assignmentAnswerContentVO) {
        // TODO Auto-generated method stub
        Date date = new Date();
        //先干掉第一次的建议
        assignmentAnswerSuggestionService.delectSuggestion(assignmentAnswerContentVO.getAnswerId());
        //先干掉第一次的批阅文件
        assignmentAnswerFileService.deleteAnswerFile(assignmentAnswerContentVO.getAnswerId());
        //老师给的建议
        if (assignmentAnswerContentVO.getComment() != null) {

            //插入第二次建议
            AssignmentAnswerSuggestion assignmentAnswerSuggestion = new AssignmentAnswerSuggestion();
            assignmentAnswerSuggestion.setId(id.generate());
            assignmentAnswerSuggestion.setAnswerId(assignmentAnswerContentVO.getAnswerId());
            assignmentAnswerSuggestion.setSuggestion(assignmentAnswerContentVO.getComment());
            assignmentAnswerSuggestion.setCreateById(assignmentAnswerContentVO.getAccountId());
            assignmentAnswerSuggestion.setCreateByName(assignmentAnswerContentVO.getAccountName());
            assignmentAnswerSuggestion.setCreateTime(date);
            assignmentAnswerSuggestionService.insert(assignmentAnswerSuggestion);
        }
        //老师给的批阅文件
        if (!CollectionUtils.isEmpty(assignmentAnswerContentVO.getListFeedBackFiles())) {

            //插入第二次批阅文件
            List<com.yizhi.assignment.application.vo.entity.AssignmentAnswerFile> feedBackFileVOList = assignmentAnswerContentVO.getListFeedBackFiles();
            List<AssignmentAnswerFile> list = new ArrayList<>();
            feedBackFileVOList.forEach(assignmentAnswerFileVO -> {
                AssignmentAnswerFile assignmentAnswerFile = new AssignmentAnswerFile();
                BeanUtils.copyProperties(assignmentAnswerFileVO, assignmentAnswerFile);
                list.add(assignmentAnswerFile);
            });

            //List<AssignmentAnswerFile> list = assignmentAnswerContentVO.getListFeedBackFiles();
            for (int i = 0; i < list.size(); i++) {
                AssignmentAnswerFile assignmentAnswerFile = new AssignmentAnswerFile();
                assignmentAnswerFile.setId(id.generate());
                assignmentAnswerFile.setAnwserId(assignmentAnswerContentVO.getAnswerId());
                assignmentAnswerFile.setType(2);  //文件类型(1:作业答案,2:评阅回复)
                assignmentAnswerFile.setFileUrl(list.get(i).getFileUrl());
                assignmentAnswerFile.setFileName(list.get(i).getFileName());
                assignmentAnswerFile.setSuffix(list.get(i).getSuffix());
                String size = list.get(i).getSize();
                if (size == null) {
                    size = "0M";
                }
                assignmentAnswerFile.setSize(size);
                assignmentAnswerFile.setPng("现在只能存图片");
                assignmentAnswerFile.setCreateById(assignmentAnswerContentVO.getAccountId());
                assignmentAnswerFile.setCreateByName(assignmentAnswerContentVO.getAccountName());
                assignmentAnswerFile.setCreateTime(date);
                assignmentAnswerFileService.insert(assignmentAnswerFile);
            }
        }


        //   先看有没有老师批阅过，如果有  是更改     如果没有老师批阅，则插入
        //插入 分数  评阅人 改变状态或者等级
        AssignmentAnswer assignmentAnswer = new AssignmentAnswer();
        assignmentAnswer.setId(assignmentAnswerContentVO.getAnswerId());//作业id   主键

        assignmentAnswer.setAuditorId(assignmentAnswerContentVO.getAccountId());  //评阅人id
        assignmentAnswer.setAuditorTime(date);
        assignmentAnswer.setStatus(2);  //状态改为已经阅读
        assignmentAnswer.setUpdateById(assignmentAnswerContentVO.getAccountId());
        assignmentAnswer.setUpdateByName(assignmentAnswerContentVO.getAccountName());
        assignmentAnswer.setScore(assignmentAnswerContentVO.getScore() > 0 ? assignmentAnswerContentVO.getScore() : 0);
        /**
         * 查询应该给多少积分
         */
        AssignmentAnswer assignmentAnswer2 = assignmentAnswerMapper.selectById(assignmentAnswerContentVO.getAnswerId());
        AssignmentPoint assignmentPoint = assignmentPointMapper.getPointByAssignmentIdAndScore(assignmentAnswer2.getAssignmentId(), assignmentAnswerContentVO.getScore());
        if (assignmentPoint != null) {
            assignmentAnswer.setPoint(assignmentPoint.getPoint());
        }
        assignmentAnswer.setUpdateTime(date);
        assignmentAnswerService.insertTeacherToStudent(assignmentAnswer);

        //培训项目用到的参数
        AssignmentAnswer assignmentAnswerTra = new AssignmentAnswer();
        //根据answerId找到作业id和accountId
        Long answerId = assignmentAnswerContentVO.getAnswerId();
        assignmentAnswerTra = assignmentAnswerService.selectById(answerId);
        final Long assignmentId = assignmentAnswerTra.getAssignmentId();
        final Long accountId = assignmentAnswerTra.getAccountId();
        final Long siteId = assignmentAnswerTra.getSiteId();


        //评分转换为float
        Float score = 0.0f;
        if (assignmentAnswerContentVO.getScore() != null) {
            int i = assignmentAnswerContentVO.getScore().intValue();
            score = (float) i;
        }
        Float scoreFloat = (float) score;

        Assignment assignmentGetPassScore = assignmentMapper.selectById(assignmentId);


        //批阅完成发消息
        if (assignmentAnswerContentVO.getScore() != null) {
            LOG.info("作业得分：" + assignmentAnswerContentVO.getScore());
            LOG.info("作业assignmentAnswerContentVO：" + JSON.toJSONString(assignmentGetPassScore));
            if (assignmentGetPassScore != null) {
                try {
                    taskExecutor.asynExecute(new AbstractTaskHandler() {
                        @Override
                        public void handle() {
                            assignmentEvenSendMessage.evenSendMessage(assignmentGetPassScore, accountId, EvenType.ASSIGNMENT_AUDIT_FINISH, assignmentAnswerContentVO.getScore().doubleValue());
                        }
                    });
                } catch (Exception e) {
                    e.printStackTrace();
                    LOG.info("作业批阅完成发消息异常");
                }
            }
        }

        if (assignmentAnswerContentVO.getScore() - assignmentGetPassScore.getPassScore() >= 0) {
            // 向培训项目发送消息，告知业务已经完成
            try {
                taskExecutor.asynExecute(new AbstractTaskHandler() {
                    @Override
                    public void handle() {
                        try {
                            cloudEventPublisher.publish(QueueConstant.TRAINING_PROJECT_EVENT_QUEUE,
                                    new EventWrapper<TrainingProjectEvent>(assignmentId,
                                            TrainingProjectEvent.getInstance(assignmentId, TpActivityType.TYPE_ASSIGNMENT, accountId, new Date(), siteId, scoreFloat, true)));
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                });
            } catch (Exception e) {
                LOG.error("培训项目发送消息失败：", e);
            }
        } else {//没有通过发false
            try {
                taskExecutor.asynExecute(new AbstractTaskHandler() {
                    @Override
                    public void handle() {
                        try {
                            cloudEventPublisher.publish(QueueConstant.TRAINING_PROJECT_EVENT_QUEUE,
                                    new EventWrapper<TrainingProjectEvent>(assignmentId,
                                            TrainingProjectEvent.getInstance(assignmentId, TpActivityType.TYPE_ASSIGNMENT, accountId, new Date(), siteId, scoreFloat, false)));
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                });
            } catch (Exception e) {
                LOG.error("培训项目发送消息失败：", e);
            }
        }


        /**
         * 发放积分
         */

        AssignmentAnswer assignmentAnswerPoint = assignmentAnswerMapper.selectById(answerId);
        Assignment assignment = null;
        if (assignmentAnswerPoint != null && assignmentAnswerPoint.getAssignmentId() != null) {
            assignment = assignmentMapper.selectById(assignmentAnswerPoint.getAssignmentId());
        }
        PointParamVO pointParamVO = new PointParamVO();
        if (assignment != null) {
            pointParamVO.setActivityName(assignment.getName());
            pointParamVO.setSourceId(assignment.getId());
        }
        pointParamVO.setCreatePointTime(date);
        if (assignmentPoint != null) {
            pointParamVO.setOperatingPoint(assignmentPoint.getPoint());
        }
        if (assignmentAnswer2 != null) {
            pointParamVO.setAccountId(assignmentAnswer2.getAccountId());        //学员ID
            pointParamVO.setAccountName(assignmentAnswer2.getAccountName());    //学员名称
            pointParamVO.setCompanyId(assignmentAnswer2.getCompanyId());        //企业ID
            pointParamVO.setSiteId(assignmentAnswer2.getSiteId());                //站点ID
            pointParamVO.setOrgId(assignmentAnswer2.getOrgId());
        }
        return pointParamVO;
    }

    private List<com.yizhi.assignment.application.vo.entity.AssignmentAnswerFile> exchangeAssignmentAnswerFile(List<AssignmentAnswerFile> listAssignmentAnswerFile) {
        List<com.yizhi.assignment.application.vo.entity.AssignmentAnswerFile> assignmentAnswerFileVoList = new ArrayList<>();
        listAssignmentAnswerFile.forEach(assignmentAnswerFile -> {
            com.yizhi.assignment.application.vo.entity.AssignmentAnswerFile assignmentAnswerFileVO = new com.yizhi.assignment.application.vo.entity.AssignmentAnswerFile();
            BeanUtils.copyProperties(assignmentAnswerFile, assignmentAnswerFileVO);
            assignmentAnswerFileVoList.add(assignmentAnswerFileVO);
        });
        return assignmentAnswerFileVoList;
    }

    @Override
    public Integer getAssignmentCountQXPT(Long siteId) {
        // TODO Auto-generated method stub
        //全平台可见的作业个数    已上架  visible_range=1 全平台可见
        Assignment assignment = new Assignment();
        assignment.setVisibleRange(1);
        assignment.setSiteId(siteId);
        assignment.setStatus(2);
        EntityWrapper<Assignment> wrapper = new EntityWrapper<Assignment>(assignment);
        return this.selectCount(wrapper);
    }


    @Override
    public AssignmentQXVO getQXSubmitMessage(Long assignmentId) {
        // TODO Auto-generated method stub
        AssignmentQXVO assignmentUnSubmitVO = new AssignmentQXVO();
        List<AssignmentStudent> listStudent = new ArrayList<AssignmentStudent>();
        Assignment assignment = new Assignment();
        assignment.setId(assignmentId);
        EntityWrapper<Assignment> wrapper = new EntityWrapper<Assignment>(assignment);
        assignment = this.selectOne(wrapper);
        if (assignment != null) {
            assignmentUnSubmitVO.setName(assignment.getName());
            assignmentUnSubmitVO.setVisibleRange(assignment.getVisibleRange());
            //全平台可见  给站点id
            assignmentUnSubmitVO.setSiteId(assignment.getSiteId());

            if (assignment.getVisibleRange() == 2) {   //指定学员可见范围
                AssignmentStudent assignmentStudent = new AssignmentStudent();
                assignmentStudent.setAssignmentId(assignmentId);
                EntityWrapper<AssignmentStudent> wrapper2 = new EntityWrapper<AssignmentStudent>(assignmentStudent);
                listStudent = assignmentStudentService.selectList(wrapper2);
                if (listStudent != null) {
                    List<com.yizhi.assignment.application.vo.entity.AssignmentStudent> studentVOList = new ArrayList<>();
                    listStudent.forEach(assignmentStudent1 -> {
                        com.yizhi.assignment.application.vo.entity.AssignmentStudent assignmentStudentVO = new com.yizhi.assignment.application.vo.entity.AssignmentStudent();
                        BeanUtils.copyProperties(assignmentStudent1, assignmentStudentVO);
                        studentVOList.add(assignmentStudentVO);
                    });
                    assignmentUnSubmitVO.setListStudent(studentVOList);
                }
            }

            //已经提交的人员id
            AssignmentAnswer assignmentAnswer = new AssignmentAnswer();
            assignmentAnswer.setAssignmentId(assignmentId);
            EntityWrapper<AssignmentAnswer> wrapper3 = new EntityWrapper<AssignmentAnswer>(assignmentAnswer);
            List<AssignmentAnswer> listAssignmentAnswer = assignmentAnswerService.selectList(wrapper3);
            List<Long> list = new ArrayList<Long>();
            if (listAssignmentAnswer != null) {
                for (int i = 0; i < listAssignmentAnswer.size(); i++) {
                    list.add(listAssignmentAnswer.get(i).getAccountId());
                }
                assignmentUnSubmitVO.setListSubmitAccountId(list);
            }
        }
        return assignmentUnSubmitVO;
    }

    @Override
    public List<ToOthersApi> listSearchOthers(String name, int pageNo, int pageSize, Long accountId, List<Long> relationIds, Long siteId) {
        // TODO Auto-generated method stub
        //分配给此人的作业idList
        Page<Long> pageLimit = new Page<Long>(pageNo, pageSize);
        List<Long> assignmentIds = assignmentStudentMapper.myAllListByName(name, relationIds, siteId, pageLimit);
        if (!CollectionUtils.isEmpty(assignmentIds)) {
            return assignmentMapper.listToOthersApi(assignmentIds);
        } else {
            return null;
        }

    }

    @Override
    public ApiAssignmentVO getAssignment(Long assignmentId, Long accountId) {
        // TODO Auto-generated method stub
        Assignment assignment = assignmentMapper.selectById(assignmentId);
        AssignmentContent assignmentContent = assignmentContentService.findByAssignmentId(assignmentId);
        List<ApiFileVo> fileList = assignmentFileMapper.listApiFileVo(assignmentId);
        ApiAssignmentVO apiAssignmentVO = new ApiAssignmentVO();
        List<AssignmentAnswer> listAssignmentAnswer = assignmentAnswerService.listAssignmentAnswerByAssignmentIdAndAccountId(assignmentId, accountId);
        if (assignment != null) {
            apiAssignmentVO.setId(assignment.getId());
            apiAssignmentVO.setAssignmentName(assignment.getName());
            apiAssignmentVO.setCount(assignment.getCount());
            apiAssignmentVO.setProjectName(assignment.getTrainingProjectName());
            apiAssignmentVO.setFinishTime(assignment.getFinishTime());
            apiAssignmentVO.setPassScore(assignment.getPassScore());
            apiAssignmentVO.setSubmitCount(listAssignmentAnswer != null ? listAssignmentAnswer.size() : 0);
            apiAssignmentVO.setAmendable(assignment.getAmendable());


            apiAssignmentVO.setAnswerAttachmentNumMax(assignment.getAnswerAttachmentNumMax());
            apiAssignmentVO.setAnswerAttachmentNumMin(assignment.getAnswerAttachmentNumMin());
            apiAssignmentVO.setAnswerCharaterNumMax(assignment.getAnswerCharaterNumMax());
            apiAssignmentVO.setAnswerCharaterNumMin(assignment.getAnswerCharaterNumMin());
            apiAssignmentVO.setShowRes(assignment.getShowRes());
            apiAssignmentVO.setEnableExerciseBook(assignment.getEnableExerciseBook());
            apiAssignmentVO.setCommitAccountNum(assignmentAnswerMapper.countCommitAccountNum(assignmentId));
        }
        if (assignmentContent != null) {
            apiAssignmentVO.setAssignmentContent(assignmentContent.getComment());
        }
        apiAssignmentVO.setFileList(fileList);
        return apiAssignmentVO;
    }

    @Override
    public VisibleRangeExport vsibleRangeExport(Long assignmentId) {
        // TODO Auto-generated method stub
        VisibleRangeExport visibleRangeExport = new VisibleRangeExport();
        List<Long> accountIds = new ArrayList<Long>();
        List<Long> orgIds = new ArrayList<Long>();
        Assignment assignment = assignmentMapper.selectById(assignmentId);
        if (assignment != null) {
            visibleRangeExport.setBizId(assignment.getId());
            visibleRangeExport.setBizName(assignment.getName());
        }
        List<AssignmentStudent> listStudent = assignmentStudentService.relation(assignmentId);
        if (listStudent != null && listStudent.size() > 0) {
            AssignmentStudent assignmentStudent = null;
            for (int i = 0; i < listStudent.size(); i++) {
                assignmentStudent = listStudent.get(i);
                if (assignmentStudent != null && assignmentStudent.getType() != null) {
                    if (assignmentStudent.getType() == 2) {
                        accountIds.add(assignmentStudent.getAccountId());
                    }
                    if (assignmentStudent.getType() == 1) {
                        orgIds.add(assignmentStudent.getAccountId());
                    }
                }
                visibleRangeExport.setAccountIds(accountIds);
                visibleRangeExport.setOrgIds(orgIds);
            }
        }
        return visibleRangeExport;
    }

    @Transactional
    @Override
    public boolean updateAssignmentTp(AssignmentTrainingProject atp) {
        // TODO Auto-generated method stub

        Long projectId = atp.getProjectId();
        String projectName = atp.getProjectName();
        List<Long> assignmentIds = atp.getListAssignmentIds();
        Set<Long> set = new HashSet<Long>();
        if (!CollectionUtils.isEmpty(assignmentIds)) {
            set.addAll(assignmentIds);
        }
        List<Long> assignmentIdsByProjectId = assignmentMapper.getAssignmentIdsByProjectId(projectId);
        set.addAll(assignmentIdsByProjectId);

        //  培训项目名字和id设置为空
        for (Long assignmentId : set) {
            assignmentMapper.updateProjectMessageByAssignmentId(assignmentId);
        }

        if (!CollectionUtils.isEmpty(assignmentIds)) {
            Assignment assignment = new Assignment();
            assignment.setTrainingProjectId(projectId);
            assignment.setTrainingProjectName(projectName);
            for (int i = 0; i < assignmentIds.size(); i++) {
                assignment.setId(assignmentIds.get(i));
                assignmentMapper.updateById(assignment);
            }
        }
        return true;
    }

    @Override
    public List<Map<String, Object>> getServerByCompanyIdAndIds(Long companyId, List<Long> ids) {
        // TODO Auto-generated method stub
        List<Map<String, Object>> listMap = null;

        Assignment assignment = new Assignment();
        assignment.setCompanyId(companyId);
        EntityWrapper<Assignment> wrapper = new EntityWrapper<Assignment>(assignment);
        if (!CollectionUtils.isEmpty(ids)) {
            wrapper.in("id", ids);
        }
        List<Assignment> listAssignment = this.selectList(wrapper);
        Map<String, Object> map = null;
        if (!CollectionUtils.isEmpty(listAssignment)) {
            listMap = new ArrayList<Map<String, Object>>();
            for (Assignment c : listAssignment) {
                map = new HashMap<String, Object>();
                map.put("catalog", 5);
                map.put("id", c.getId());
                map.put("name", c.getName());
                map.put("logo_url", "");
                listMap.add(map);
            }
        }
        return listMap;
    }


    @Override
    public Page<ApiAssignmentListResultVO> listUnfinishedAssignment(int pageNo, int pageSize, Long accountId, List<Long> relationIds, Long companyId, Long siteId) {
        // TODO Auto-generated method stub
        Page<ApiAssignmentListResultVO> pageRecords = new Page<ApiAssignmentListResultVO>(pageNo, pageSize);
        List<ApiAssignmentListResultVO> listApiAssignmentListResultVO = null;

        //未完成的作业列表中作业ids
        Page<Long> pageLimit = new Page<Long>(pageNo, pageSize);
        List<Long> assignmentIds = assignmentStudentMapper.listUnFinishIds(relationIds, companyId, siteId, accountId, pageLimit);
        if (CollectionUtils.isNotEmpty(assignmentIds)) {
            listApiAssignmentListResultVO = assignmentStudentMapper.listUnfinish(companyId, siteId, accountId, assignmentIds);
            if (CollectionUtils.isNotEmpty(listApiAssignmentListResultVO)) {
                for (ApiAssignmentListResultVO apiAssignmentListResultVO : listApiAssignmentListResultVO) {
                    Assignment assignment = assignmentMapper.selectById(apiAssignmentListResultVO.getId());
//	        		apiAssignmentListResultVO.setScore(assignmentStudentMapper.maxGradeByAccountId(companyId, siteId, accountId, apiAssignmentListResultVO.getId()));
                    apiAssignmentListResultVO.setShowRes(assignment.getShowRes());
                    //提交过
                    if (apiAssignmentListResultVO.getSubmitCount() > 0) {
                        //全部被评阅
                        if (apiAssignmentListResultVO.getMinAnswerStatus() == 2) {
                            if (apiAssignmentListResultVO.getScore() >= apiAssignmentListResultVO.getPassScore()) {
                                apiAssignmentListResultVO.setStatus(AssignmentConstant.PASS.getCode());
                                apiAssignmentListResultVO.setIsPass(1);
                            } else {
                                apiAssignmentListResultVO.setStatus(AssignmentConstant.NO_PASS.getCode());
                                //aalrv.setTag("已提交未完成");
                                apiAssignmentListResultVO.setScore(apiAssignmentListResultVO.getScore());
                                apiAssignmentListResultVO.setIsPass(2);
                            }

                            //允许不允许补交
                            if (apiAssignmentListResultVO.getAmendable() == 1) {
                                if (apiAssignmentListResultVO.getCount() - apiAssignmentListResultVO.getSubmitCount() > 0) {
                                    apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.CONTINUEDETAIL.getCode());
                                } else {
                                    apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.DETAIL.getCode());
                                }
                            } else {
                                apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.DETAIL.getCode());
                            }
                            // 获取作业答案的分数等级
                            Long assignmentId = apiAssignmentListResultVO.getId();
                            Integer maxGrade = apiAssignmentListResultVO.getScore();
                            AssignmentGrade assignmentGrade = assignmentGradeMapper.getGradeByAssignmentIdAndScore(assignmentId, maxGrade);
                            if (assignmentGrade != null) {
                                apiAssignmentListResultVO.setGradeLeval(assignmentGrade.getDescription());
                            }
                        }
                        //只要有一个未被评阅
                        else {
                            apiAssignmentListResultVO.setTag("待评阅");
                            apiAssignmentListResultVO.setStatus(AssignmentConstant.MARKING.getCode());
                            if (apiAssignmentListResultVO.getCount() > apiAssignmentListResultVO.getSubmitCount()) {
                                apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.CONTINUEDETAIL.getCode());
                            } else {
                                apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.DETAIL.getCode());
                            }
                        }

                    }
                    //实际提交次数为0
                    else {
                        apiAssignmentListResultVO.setTag("待提交");
                        apiAssignmentListResultVO.setStatus(AssignmentConstant.SUBMISSION.getCode());
                        apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.SUBMIT.getCode());

                        Integer submitCount = assignmentAnswerMapper.selectAnswerCount(apiAssignmentListResultVO.getId(), accountId, null);
                        LOG.info("提交的次数：{}", submitCount);
                        if (submitCount > 0) {
                            apiAssignmentListResultVO.setIsPass(2);
                            apiAssignmentListResultVO.setStatus(AssignmentConstant.NO_PASS.getCode());
                            apiAssignmentListResultVO.setTag("");
                            apiAssignmentListResultVO.setScore(-1);
                            apiAssignmentListResultVO.setHandle(5);
                        }
                    }

                }
            }
        }
        pageRecords.setRecords(listApiAssignmentListResultVO);
        pageRecords.setTotal(pageLimit.getTotal());
        return pageRecords;
    }

    @Override
    public Page<ApiAssignmentListResultVO> listFinishedAssignment(int pageNo, int pageSize, Long accountId, List<Long> relationIds, Long companyId, Long siteId) {

        List<ApiAssignmentListResultVO> list = null;
        Page<ApiAssignmentListResultVO> page = new Page<ApiAssignmentListResultVO>();

        Page<Long> pageLimit = new Page<Long>(pageNo, pageSize);
        List<Long> assignmentIds = assignmentStudentMapper.listFinishIds(relationIds, companyId, siteId, accountId, pageLimit);
        if (CollectionUtils.isNotEmpty(assignmentIds)) {
            list = assignmentStudentMapper.listFinish(companyId, siteId, accountId, assignmentIds);
            if (CollectionUtils.isNotEmpty(list)) {
                for (ApiAssignmentListResultVO apiAssignmentListResultVO : list) {
                    //提交次数大于0
                    Assignment assignment = assignmentMapper.selectById(apiAssignmentListResultVO.getId());
//	        		apiAssignmentListResultVO.setScore(assignmentStudentMapper.maxGradeByAccountId(companyId, siteId, accountId, apiAssignmentListResultVO.getId()));
                    apiAssignmentListResultVO.setShowRes(assignment.getShowRes());
//                    AssignmentAnswer answer = new AssignmentAnswer();
//                    answer.setAssignmentId(apiAssignmentListResultVO.getId());
//                    answer.setDeleted(0);
//                    int submitCount = assignmentAnswerService.selectCount(QueryUtil.condition(answer));
//                    LOG.info("提交次数：{}",submitCount);
                    apiAssignmentListResultVO.getSubmitCount();
                    if (apiAssignmentListResultVO.getSubmitCount() == 0) {
//	        		if(submitCount==0) {
                        if (apiAssignmentListResultVO.getIsOverDue() == 2) {
                            apiAssignmentListResultVO.setTag("已逾期");
                            apiAssignmentListResultVO.setStatus(AssignmentConstant.Delay.getCode());
                            if (apiAssignmentListResultVO.getAmendable() == 0) {
                                // 无补交
                                apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.NO_HANDLE.getCode());
                            } else {
                                // 有补交
                                if (apiAssignmentListResultVO.getCount() - apiAssignmentListResultVO.getSubmitCount() > 0) {
                                    apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.SUBMIT.getCode());
                                } else {
                                    apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.NO_HANDLE.getCode());
                                }
                            }
                        }
                        Integer submitCount = assignmentAnswerMapper.selectAnswerCount(apiAssignmentListResultVO.getId(), accountId, 0);
                        LOG.info("提交的次数：{}", submitCount);
                        if (submitCount == apiAssignmentListResultVO.getCount()) {
                            apiAssignmentListResultVO.setIsPass(2);
                            apiAssignmentListResultVO.setStatus(AssignmentConstant.NO_PASS.getCode());
                            apiAssignmentListResultVO.setTag("");
                            apiAssignmentListResultVO.setScore(-1);
                            apiAssignmentListResultVO.setHandle(AssignmentConstant.MARKING.getCode());
                        }
                        if (submitCount == 0) {
                            apiAssignmentListResultVO.setIsPass(2);
                            apiAssignmentListResultVO.setStatus(AssignmentConstant.NO_PASS.getCode());
                            apiAssignmentListResultVO.setTag("");
                            apiAssignmentListResultVO.setScore(-1);
                            apiAssignmentListResultVO.setHandle(AssignmentConstant.MARKING.getCode());
                        }

                    }
                    //提交过
                    else {
                        AssignmentAnswer answer = new AssignmentAnswer();
                        answer.setAssignmentId(apiAssignmentListResultVO.getId());
                        answer.setIsDown(0);
                        answer.setAccountId(accountId);
                        int count = assignmentAnswerService.selectCount(QueryUtil.condition(answer));
                        LOG.info("当前的未下架数量：{}", count);

                        if (apiAssignmentListResultVO.getAmendable() == 1) {
                            Integer currentSubmitCount = assignmentAnswerMapper.selectAnswerCount(apiAssignmentListResultVO.getId(), accountId, null);
                            LOG.info("总计次数：{}", currentSubmitCount);
                            if (apiAssignmentListResultVO.getCount() - currentSubmitCount > 0) {
                                apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.CONTINUEDETAIL.getCode());
                            } else {
                                apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.DETAIL.getCode());
                            }
                        } else {
                            apiAssignmentListResultVO.setHandle(AssignmentHandleConstant.DETAIL.getCode());
                        }
                        boolean res = apiAssignmentListResultVO.getMinAnswerStatus() == 1;
                        boolean isYq = apiAssignmentListResultVO.getIsOverDue() == 1;
                        if (res & isYq) {
                            apiAssignmentListResultVO.setStatus(AssignmentConstant.MARKING.getCode());
                        }

                        boolean minAnswerStatus = apiAssignmentListResultVO.getMinAnswerStatus() == 1;

                        if (minAnswerStatus) {
                            apiAssignmentListResultVO.setTag("评阅中");
                            apiAssignmentListResultVO.setStatus(AssignmentConstant.MARKING.getCode());
                        }

                        if (!minAnswerStatus) {
                            Long assignmentId = apiAssignmentListResultVO.getId();
                            Integer maxGrade = apiAssignmentListResultVO.getScore();
                            AssignmentGrade assignmentGrade = assignmentGradeMapper.getGradeByAssignmentIdAndScore(assignmentId, maxGrade);
                            if (maxGrade.compareTo(apiAssignmentListResultVO.getPassScore()) >= 0) {
                                //aalrv.setTag("已提交已完成");
                                apiAssignmentListResultVO.setScore(maxGrade);
                                if (assignmentGrade != null) {
                                    apiAssignmentListResultVO.setGradeLeval(assignmentGrade.getDescription());
                                }
                                apiAssignmentListResultVO.setIsPass(1);
                                apiAssignmentListResultVO.setStatus(AssignmentConstant.PASS.getCode());
                            } else {
                                if (assignmentGrade != null) {
                                    apiAssignmentListResultVO.setGradeLeval(assignmentGrade.getDescription());
                                }
                                apiAssignmentListResultVO.setIsPass(2);
                                apiAssignmentListResultVO.setStatus(AssignmentConstant.NO_PASS.getCode());
                            }
                        }


                        if (count == 0) {
                            apiAssignmentListResultVO.setIsPass(2);
                            apiAssignmentListResultVO.setStatus(AssignmentConstant.NO_PASS.getCode());
                            apiAssignmentListResultVO.setTag("");
                            apiAssignmentListResultVO.setScore(-1);
                        }
                    }
                    if (apiAssignmentListResultVO.getIsOverDue() == 1 && AnswerFileTypeEnum.ANSWER.equals(apiAssignmentListResultVO.getAmendable())) {
                        apiAssignmentListResultVO.setStatus(AssignmentConstant.MARKUP.getCode());
                    }

//                    if (accountId != null) {
//                        Integer currentScore = apiAssignmentListResultVO.getScore();
//                        if (currentScore != null) {
//                            int maxScore = assignmentAnswerMapper.getScore(apiAssignmentListResultVO.getId(), null, null, accountId);
//                            LOG.info("返回最大的分数：{}", maxScore);
//                            apiAssignmentListResultVO.setScore(maxScore);
//                        }
//                    }
                }
            }
        }
        page.setTotal(pageLimit.getTotal());
        page.setRecords(list);
        return page;
    }

    @Override
    public Integer delete(Long assignmentId) {
        // TODO Auto-generated method stub
        return assignmentMapper.delete(assignmentId);

    }

    @Override
    public Page<Map<String, Object>> experiencePoolList(String name, List<Long> ids, Integer pageNo, Integer pageSize) {
        // TODO Auto-generated method stub
        RequestContext res = ContextHolder.get();
        Long companyId = res.getCompanyId();
        Long siteId = res.getSiteId();
        Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
        List<Map<String, Object>> list = new ArrayList<>();
        String name1 = null;
        if (StringUtils.isNotBlank(name)) {
            name1 = name.trim();
        }
        HQueryUtil.startHQ(Assignment.class);
        list = assignmentMapper.experiencePoolList(name1, ids, companyId, siteId, page);
        if (CollectionUtils.isNotEmpty(list)) {
            page.setRecords(list);
        }
        return page;
    }

    @Override
    public Page<AssignmentCalendarVO> getPageToCalendar(Date date, Page<Assignment> page) {

        RequestContext context = ContextHolder.get();
        Long siteId = context.getSiteId();
        Long accountId = context.getAccountId();
        Page<AssignmentCalendarVO> voPage = new Page<>();
        BeanUtils.copyProperties(page, voPage);
        //获取该时间参数的作业ids
        List<Long> ids = assignmentMapper.getIdsByDate(date, siteId);
        if (CollectionUtils.isEmpty(ids)) {
            return voPage;
        }
        //获取已通过的ids
        Set<Long> passIds = new HashSet<>();
        //获取未通过的ids
        Set<Long> unPassIds = new HashSet<>();
        //获取已结束的ids
        Set<Long> endIds = new HashSet<>();
        //获取待批阅的ids
        Set<Long> auditingIds = new HashSet<>();
        //获取含有未提交的id的集合
        Set<Long> unAnswerIds = new HashSet<>();
        unAnswerIds.addAll(ids);
        //储存《作业id,允许参加作业的次数》
        Map<Long, Integer> canJoinAssignmnetNumMap = new HashMap<>();
        //储存《作业id,已参加对应作业的次数》
        Map<Long, Integer> hasJoinAssignmnetNumMap = new HashMap<>();

        //根据可见范围获取作业ids
        List<Long> assignmentIdsFromVisibRange = CollectionUtils.isEmpty(context.getRelationIds()) ? null : assignmentStudentMapper.getUsefulIds(ids, context.getRelationIds(), siteId);
        //根据ids获取的相关作业提交记录
        List<AssignmentAnswer> joinAssignments = assignmentAnswerMapper.getJoinIdsByIds(siteId, accountId, ids);
        if (CollectionUtils.isNotEmpty(joinAssignments)) {
            for (AssignmentAnswer a : joinAssignments) {
                Assignment assignment = assignmentMapper.selectById(a.getAssignmentId());
                if (assignment != null) {
                    Long assignmentId = assignment.getId();
                    if (a.getStatus() == 2) {//已阅
                        if (a.getScore() >= assignment.getPassScore()) {
                            passIds.add(assignmentId);
                        } else {
                            unPassIds.add(assignmentId);
                        }
                    } else if (a.getStatus() == 1) {//未阅
                        auditingIds.add(assignmentId);
                    }
                    if (!canJoinAssignmnetNumMap.containsKey(assignmentId)) {
                        canJoinAssignmnetNumMap.put(assignmentId, assignment.getCount());
                    }
                    if (hasJoinAssignmnetNumMap.containsKey(assignmentId)) {
                        hasJoinAssignmnetNumMap.put(assignmentId, hasJoinAssignmnetNumMap.get(assignmentId) + 1);
                    } else {
                        hasJoinAssignmnetNumMap.put(assignmentId, 1);
                    }
                    unAnswerIds.remove(a.getAssignmentId());
                } else {
                    LOG.info("该作业为空" + a.getAssignmentId());
                }
            }
            for (Long id : ids) {
                Integer canJoinAssignmnetNum = canJoinAssignmnetNumMap.get(id);
                Integer hasJoinAssignmnetNum = hasJoinAssignmnetNumMap.get(id);

                if (canJoinAssignmnetNum != null && hasJoinAssignmnetNum != null) {
                    if (hasJoinAssignmnetNum >= canJoinAssignmnetNum) {
                        endIds.add(id);
                    }
                }
            }
        }

        //展示的数据需要剔除已结束、已通过的作业
        endIds.addAll(passIds);
        //获取最终数据
        List<Assignment> pageToCalendar = assignmentMapper.getPageToCalendar(new ArrayList<>(endIds), assignmentIdsFromVisibRange, date, siteId, page);
        voPage.setTotal(assignmentMapper.getPageToCalendarNum(new ArrayList<>(endIds), assignmentIdsFromVisibRange, date, siteId));
        voPage.setRecords(buildAssignmentVo(pageToCalendar, auditingIds, unAnswerIds, unPassIds));
        return voPage;
    }

    /**
     * 组建作业状态
     *
     * @return
     */
    public List<AssignmentCalendarVO> buildAssignmentVo(List<Assignment> assignments, Set<Long> auditingIds, Set<Long> unAnswerIds, Set<Long> unPassIds) {

        List<AssignmentCalendarVO> vos = new ArrayList<>(assignments.size());
        if (CollectionUtils.isNotEmpty(assignments)) {
            for (Assignment a : assignments) {
                AssignmentCalendarVO vo = new AssignmentCalendarVO();
                BeanUtils.copyProperties(a, vo);
                if (auditingIds.contains(a.getId())) {
                    vo.setTaskStatus(2);
                    vo.setTaskTag(ButtonStatus.TO_BE_REVIEWED.getCode());//待批阅
                    vo.setTaskButtonStatus(Arrays.asList(ButtonStatus.SUMMIT_GO.getCode(), ButtonStatus.VIEW_DETAILS.getCode()));//继续提交、查看详情
                } else if (unAnswerIds.contains(a.getId())) {
                    vo.setTaskStatus(1);
                    vo.setTaskTag(ButtonStatus.NOT_SUMMITED.getCode());//未提交
                    vo.setTaskButtonStatus(Arrays.asList(ButtonStatus.SUMMIT.getCode()));//提交作业
                } else if (unPassIds.contains(a.getId())) {
                    vo.setTaskStatus(3);
                    vo.setTaskTag(ButtonStatus.FAILED.getCode());//未通过
                    vo.setTaskButtonStatus(Arrays.asList(ButtonStatus.SUMMIT_GO.getCode(), ButtonStatus.VIEW_DETAILS.getCode()));
                    if (auditingIds.contains(a.getId())) {
                        vo.setTaskStatus(2);
                        vo.setTaskTag(ButtonStatus.TO_BE_REVIEWED.getCode());//待批阅
                    }
                }
                vos.add(vo);
            }
        }
        return vos;
    }

    public Integer getNotNull(Integer a) {
        a = a == null ? 0 : a;
        return a;
    }

    @Override
    public Page<DroolsVo> getPageByDrools(String field, String value, Page<DroolsVo> page) {
        if (StringUtils.isBlank(field)) {
            LOG.info("列名不能为空！");
            return page;
        }

        if (field.equalsIgnoreCase(TaskParamsEnums.NAME.getCode())) {
            return getPage(field, value, page);
        } else if (field.equalsIgnoreCase(TaskParamsEnums.KEYWORD.getCode())) {
            field = "keywords";
            return getPage(field, value, page);
        }
        return page;
    }

    public Page getPage(String field, String value, Page<DroolsVo> page) {
        RequestContext requestContext = ContextHolder.get();
        Long siteId = requestContext.getSiteId();
        Long companyId = requestContext.getCompanyId();

        Assignment assignment = new Assignment();
        assignment.setSiteId(siteId);
        assignment.setCompanyId(companyId);
        assignment.setStatus(2);
        EntityWrapper wrapper = new EntityWrapper(assignment);
        wrapper.setSqlSelect("distinct(" + field + ")," + "id ")
                .isNotNull(field)
                .like(field, value)
                .addFilter(field + "!=''")
                .orderBy("create_time", false);

        String upperField = ClassUtil.getFieldName(field);
        List<DroolsVo> voList = null;
        List<Assignment> list = this.baseMapper.selectPage(page, wrapper);
        if (!CollectionUtils.isEmpty(list)) {
            voList = new ArrayList<>(list.size());
            for (Assignment a : list) {
                DroolsVo vo = new DroolsVo();
                vo.setTaskId(a.getId());
                vo.setTaskFieldValue(ClassUtil.invokeMethod(a, upperField));
                vo.setTaskParamsType(field);
                voList.add(vo);
            }
            page.setRecords(voList);
        }
        return page;
    }
}
