package com.yizhi.application.util;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import com.yizhi.core.application.exception.FileReadException;
 
@Component
public class FileReadUtil {
	
	 private static final Logger LOG = LoggerFactory.getLogger(FileReadUtil.class);
	 
	 public  File read(String urlStr, String savePath, String fileName) {

	        File fileInfo = null;
	        try {
	            URL url = new URL(urlStr);
	            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
	            //得到输入流
	            InputStream inputStream = conn.getInputStream();
	            //获取自己数组
	            byte[] buffer = new byte[1024];
	            int len = 0;
	            ByteArrayOutputStream bos = new ByteArrayOutputStream();
	            while ((len = inputStream.read(buffer)) != -1) {
	                bos.write(buffer, 0, len);
	            }
	            bos.close();

	            byte[] getData = bos.toByteArray();
	            //文件保存位置
	            File saveDir = new File(savePath);
	            if (!saveDir.exists()) {
	                saveDir.mkdir();
	            }
	            fileInfo = new File(saveDir + File.separator + fileName);
	            FileOutputStream fos = new FileOutputStream(fileInfo);
	            fos.write(getData);
	            if (fos != null) {
	                fos.close();
	            }
	            if (inputStream != null) {
	                inputStream.close();
	            }
	        } catch (Exception e) {
	            LOG.error("文件拉取失败", e);
	            throw new FileReadException();
	        }
	        return fileInfo;
	    }


}
